function rho=naiveeigenv(a)
n=size(a,1)
x=a
t=mptrace(a)
for i=2:n
	x=x*a
	t=t + (mptrace(x)).^(1/i)
end
rho=t

function g=mp_2_graph(a)
[ij,v]=spget(sparse(a))
g=mat_2_graph(sparse(ij,ones(1,size(ij,1))),1,'node-node')
g('edge_name')=string(plustimes(v))'

function b=dadinv(a,v)
b=diag(v'\%1)*a*diag(v)

function varargout=eigenspace(a)
// eigenspace for the maximal eigenvalue
// (for the characterization of the eigenspace for the others eigenvalues
// see e.g. cite[chap 4]{gaubert92a} and cite{maxplus97}
n=size(a,1)
[chi,v]=howard(a)
rho=%ones(1,n)*chi
anorm=rho^(-1)*a
b=dadinv(anorm,v)
[ir,ic]=find(b==#(0))
g=mat_2_graph(sparse([ir',ic'],ones(1,size(ir,2)),[n,n]),1,'node-node');
[ncomp,nc]=strong_connex(g)
c=plus(anorm)
//we select one node per strongly connected component
basis=[]
for i=1:ncomp
	j=min(find(nc==i))
	if (c(j,j)==%1)
		basis=[basis,c(:,j)]
	end
end
varargout=list(basis,rho)

function varargout=mpprojspec(a)
n=size(a,1)
[chi,v]=howard(a)
rho=%ones(1,n)*chi
anorm=rho^(-1)*a
b=dadinv(anorm,v)
[ir,ic]=find(b==#(0))
g=mat_2_graph(sparse([ir',ic'],ones(1,size(ir,2)),[n,n]),1,'node-node');
[ncomp,nc]=strong_connex(g)
c=plus(anorm)
//we select one node per strongly connected component
P=%zeros(n,n)
ncx=0
for i=1:ncomp
	j=min(find(nc==i))
	if (c(j,j)==%1) then
	  ncx=ncx+1
	  P=P+c(:,j)*c(j,:)
	end
end
varargout=list(P,ncx)


function j=nicecolor(i)
v=[2 3 7 11 9 14 12  ]
j=v(modulo(i-1,7)+1)


function varargout=spectral_analysis(a)
//first, we build the graph of the matrix
ga=mp_2_graph(a);
n=size(a,1)
[chi,v]=howard(a)
rho=%ones(1,n)*chi
anorm=rho^(-1)*a
b=dadinv(anorm,v)
c=plus(b)
[ir,ic]=find(b==#(0))
//here is the saturation graph of a
g=mat_2_graph(sparse([ir',ic'],ones(1,size(ir,2)),[n,n]),1,'node-node');
[ncomp,nc]=strong_connex(g)
head=ga('head')
tail=ga('tail')
va=zeros(1,arc_number(ga))
wa=zeros(1,n)
for i=1:(arc_number(ga))
	colortail=nc(tail(i))
	j=head(i)
	if ((colortail==nc(j))& c(j,j)==#(0)) then
	          color=nicecolor(colortail)
		  va(i)=color
		  wa(tail(i))=color
	end
end
ga('edge_color')=va
ga('node_color')=wa
varargout=list(ga,g,rho,chi,v)

